Permission (Java Card API, Connected Edition)
Date: 2009-12-11

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.security
Class Permission

    java.lang.Object
      java.security.Permission

Direct Known Subclasses:
  BasicPermission, URIPermission

    @TransactionType(value=NOT_SUPPORTED)
    public abstract class Permission

extends Object

Abstract class for representing access to a system resource. All permissions have a name (whose interpretation depends on the subclass), as well as abstract functions for defining the semantics of the particular Permission subclass.

Most Permission objects also include an "actions" list that tells the actions that are permitted for the object. For example, for a `javacardx.io.ConnectorPermission` object, the permission name is the URL of a file (or directory), and the actions list (such as "read, write") specifies which actions are granted for the specified file (or for files in the specified directory). The actions list is optional for Permission objects, such as `javacardx.framework.JCRuntimePermission`, that don't need such a list; you either have the named permission (such as "thread.create") or you don't.

An important method that must be implemented by each subclass is the `implies` method to compare Permissions. Basically, "permission p1 implies permission p2" means that if one is granted permission p1, one is naturally granted permission p2. Thus, this is not an equality test, but rather more of a subset test.

Permission objects are similar to String objects in that they are immutable once they have been created. Subclasses should not provide methods that can change the state of a permission once it has been created.

This Java Card class is a subset of the CDC 1.1 Permission class. Some interfaces, methods and/or variables have been pruned, and/or other methods simplified, in an effort to reduce the size of this class and/or eliminate dependencies on unsupported features.

Since:
  CDC 1.0, Java Card 3.0

Constructor Summary
`Permission(String name)` Constructs a permission with the specified name.

Method Summary
`abstract boolean` | `equals(Object obj)` Checks two Permission objects for equality.
`abstract String` | `getActions()` Returns the actions as a String.
`String` | `getName()` Returns the name of this Permission.
`abstract int` | `hashCode()` Returns the hash code value for this Permission object.
`abstract boolean` | `implies(Permission permission)` Checks if the specified permission's actions are "implied by" this object's actions.
`String` | `toString()` Returns a string describing this Permission.

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Permission

    public Permission(String name)

  Constructs a permission with the specified name.

  Parameters:
    `name` - name of the Permission object being created.

Method Detail

### implies

    public abstract boolean implies(Permission permission)

  Checks if the specified permission's actions are "implied by" this object's actions.

  This must be implemented by subclasses of Permission, as they are the only ones that can impose semantics on a Permission object.

  The `implies` method is used by the AccessController to determine whether or not a requested permission is implied by another permission that is known to be valid in the current execution context.

  Parameters:
    `permission` - the permission to check against.
  Returns:
    true if the specified permission is implied by this object, false if not.

### equals

    public abstract boolean equals(Object obj)

  Checks two Permission objects for equality.

  Do not use the `equals` method for making access control decisions; use the `implies` method.

  Overrides:
    `equals` in class `Object`
  Parameters:
    `obj` - the object we are testing for equality with this object.
  Returns:
    true if both Permission objects are equivalent.
  See Also:
    `Boolean.hashCode()`, `Hashtable`

### hashCode

    public abstract int hashCode()

  Returns the hash code value for this Permission object.

  The required `hashCode` behavior for Permission Objects is the following:

  - Whenever it is invoked on the same Permission object more than once during an execution of a Java application, the `hashCode` method must consistently return the same integer. This integer need not remain consistent from one execution of an application to another execution of the same application.

  - If two Permission objects are equal according to the `equals` method, then calling the `hashCode` method on each of the two Permission objects must produce the same integer result.

  Overrides:
    `hashCode` in class `Object`
  Returns:
    a hash code value for this object.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

### getName

    public final String getName()

  Returns the name of this Permission. For example, in the case of a `javacardx.io.ConnectorPermission`, the name will be a pathname.

  Returns:
    the name of this Permission.

### getActions

    public abstract String getActions()

  Returns the actions as a String. This is abstract so subclasses can defer creating a String representation until one is needed. Subclasses should always return actions in what they consider to be their canonical form. For example, two ConnectorPermission objects created via the following:

       perm1 = new ConnectorPermission(p1, "read,write");
       perm2 = new ConnectorPermission(p2, "write,read");

  both return "read,write" when the `getActions` method is invoked.

  Returns:
    the actions of this Permission.

### toString

    public String toString()

  Returns a string describing this Permission. The convention is to specify the class name, the permission name, and the actions in the following format: '("ClassName" "name" "actions")'.

  Overrides:
    `toString` in class `Object`
  Returns:
    information about this Permission.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2009 Sun Microsystems, Inc. All rights reserved.